/* Bard's Tale TPW Dump */
#include "tpw.h"
#include "char.h"
#include "party.h"
#include "btce.h"

#include <stdio.h>
#include <stdlib.h>

INT16 tpwdump(INT16 argc, char *fname, INT16 csv) {
FILE * fpin;
struct TPW tpw;
struct PARTY party;
struct BARDCHAR bard;
INT16 i;

if (csv && (argc==2)) {
	csvDumpHeader();
	return EXIT_SUCCESS;
}

if (fpin = fopen(fname,"rb")) {
  if (fgetTPW(&tpw, fpin)) {
    if (isparty(tpw)) {
      if (getparty(&party,fpin)) {
	if (csv) 
	printf("%s,%s,Party\n", fname, tpw.name);
	else
        printf("%-12s %-14s Party\n", fname, tpw.name);
      } else { /* get party */
	printf("\nParty read failed!\n");
	return EXIT_FAILURE;
      } /* get party */
    } else { /* is party ? */
	if (csv)
      printf("%s,%s,", fname, tpw.name);
	else
      printf("%-12s %-14s ", fname, tpw.name);

      fgetBardCharacter(&bard, fpin);
	if (csv)
      csvDumpChar(&bard);
	else
      shortDumpChar(&bard);
    } /* is party ? */
  } else { /* read tpw */
    printf("TPW read failed!\n");
    return EXIT_FAILURE;
  } /* read tpw */
  return EXIT_SUCCESS;
} else { /* read file */
  printf("Unable to read %s!", fname);
  return EXIT_FAILURE;
} /* read file */
} /* tpwdump */

